config/routes.rb
Rails.application.routes.draw do
  resources :hellos, param: :version
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/hello.rb
class Hello < ApplicationRecord
  self.primary_key = "version"

  def to_param
    version
  end
end

app/controllers/application_controller.rb
class ApplicationController < ActionController::Base
end

app/controllers/hellos_controller.rb
class HellosController < ApplicationController
  before_action :set_hello, only: %i[ show edit update destroy ]

  # GET /hellos or /hellos.json
  def index
    @hellos = Hello.all
  end

  # GET /hellos/1 or /hellos/1.json
  def show
  end

  # GET /hellos/new
  def new
    @hello = Hello.new
  end

  # GET /hellos/1/edit
  def edit
  end

  # POST /hellos or /hellos.json
  def create
    @hello = Hello.new(hello_params)

    respond_to do |format|
      if @hello.save
        format.html { redirect_to hello_url(@hello), notice: "Hello was successfully created." }
        format.json { render :show, status: :created, location: @hello }
      else
        format.html { render :new, status: :unprocessable_entity }
        format.json { render json: @hello.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /hellos/1 or /hellos/1.json
  def update
    respond_to do |format|
      if @hello.update(hello_params)
        format.html { redirect_to hello_url(@hello), notice: "Hello was successfully updated." }
        format.json { render :show, status: :ok, location: @hello }
      else
        format.html { render :edit, status: :unprocessable_entity }
        format.json { render json: @hello.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /hellos/1 or /hellos/1.json
  def destroy
    @hello.destroy

    respond_to do |format|
      format.html { redirect_to hellos_url, notice: "Hello was successfully destroyed." }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_hello
      @hello = Hello.find(params[:version])
    end

    # Only allow a list of trusted parameters through.
    def hello_params
      params.require(:hello).permit(:version, :message)
    end
end

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/hellos_helper.rb
module HellosHelper
end

app/views/hellos/_form.html.erb
<%= form_with(model: hello) do |form| %>
  <% if hello.errors.any? %>
    <div style="color: red">
      <h2><%= pluralize(hello.errors.count, "error") %> prohibited this hello from being saved:</h2>

      <ul>
        <% hello.errors.each do |error| %>
          <li><%= error.full_message %></li>
        <% end %>
      </ul>
    </div>
  <% end %>

  <div>
    <%= form.label :version, style: "display: block" %>
    <%= form.text_field :version %>
  </div>

  <div>
    <%= form.label :message, style: "display: block" %>
    <%= form.text_field :message %>
  </div>

  <div>
    <%= form.submit %>
  </div>
<% end %>

app/views/hellos/_hello.html.erb
<div id="<%= dom_id hello %>">
  <p>
    <strong>Version:</strong>
    <%= hello.version %>
  </p>
  <p>
    <strong>Message:</strong>
    <%= hello.message %>
  </p>

</div>

app/views/hellos/edit.html.erb
<h1>Editing hello</h1>

<%= render "form", hello: @hello %>

<br>

<div>
  <%= link_to "Show this hello", @hello %> |
  <%= link_to "Back to hellos", hellos_path %>
</div>

app/views/hellos/index.html.erb
<p style="color: green"><%= notice %></p>

<h1>Hellos</h1>

<div id="hellos">
  <% @hellos.each do |hello| %>
    <%= render hello %>
    <p>
      <%= link_to "Show this hello", hello %>
    </p>
  <% end %>
</div>

<%= link_to "New hello", new_hello_path %>

app/views/hellos/new.html.erb
<h1>New hello</h1>

<%= render "form", hello: @hello %>

<br>

<div>
  <%= link_to "Back to hellos", hellos_path %>
</div>

app/views/hellos/show.html.erb
<p style="color: green"><%= notice %></p>

<%= render @hello %>

<div>
  <%= link_to "Edit this hello", edit_hello_path(@hello) %> |
  <%= link_to "Back to hellos", hellos_path %>

  <%= button_to "Destroy this hello", @hello, method: :delete %>
</div>

app/views/layouts/application.html.erb
<!DOCTYPE html>
<html>
  <head>
    <title>ClickhouseRails</title>
    <meta name="viewport" content="width=device-width,initial-scale=1">
    <%= csrf_meta_tags %>
    <%= csp_meta_tag %>

    <%= stylesheet_link_tag "application", "data-turbo-track": "reload" %>
  </head>

  <body>
    <%= yield %>
  </body>
</html>